//******************************************************************************
// This class is part of the Sizmek ######################### Ad Feature
// ALL RIGHTS RESERVED TO © 2017 Sizmek.
//******************************************************************************
//******************************************************************************
// 2.0.4 added adkit verification

(function() {
	// Define Method - Update "FeatureName" with name of Ad Feature
	window.youTubeAdFeature = function(_c) {

		"use strict";
		// Verify that Adkit
		if (document.location.protocol !== "file:" && (typeof EB === "undefined" || typeof EBG === "undefined")) {
			// Console error
			log('Adkit not ready');
			// abandon script
			return false;
		}

		// Establish Boolean for tracking
		if(!window.trackYouTubeFeature) window.trackYouTubeFeature = false;
		// Save Reference to Script Name
		var scriptName = "youtube";
		// Script Version
		var scriptVersion = "2.0.0";
		// Last Modified
		var lastModified = "2018-03-16";
		// Last Uploaded
		var lastUploaded = "2018-03-16";
		// Template Version
		var templateVersion = "2.0.4";
		// Block Id
		var blockId = "6231";
		// Establish Config Object
		var config = _c;
		// Establish Boolean for tracking
		var isDebug = false;
		// Establish Boolean to track if YouTube Script has been loaded
		var youtubeAPILoaded = false;
		// Determine Format
		var isStandard;
		// Create Object to hold YouTube Players
		var youtubePlayer;
		// Establish Reference to Asset Id
		var youTubeVideoID = config.youtubeVideoId;

		// Establish Reference to this
		var self = this;
		// Function That Creates Element Var
		var d = function(_id) {
			return document.getElementById(_id);
		};

		// Set up Script
		var init = function() {
			// Show Content - Flicker Fix
			document.body.style.display = "block";

			// Get Format
			try {
				isStandard = EB._adConfig.templateName === "Html5Banner" ? true : false;
			}
			catch (err) {}

			for (var i = 0; i < document.head.childNodes.length; i++) {
				if (document.head.childNodes[i].src && document.head.childNodes[i].src.indexOf("youtube.com/iframe_api") != -1) {
					// Update Boolean
					youtubeAPILoaded = true;
				}
			}
			// Check if YouTube Script has been added already && ad isn't Standard and track the adFeature.
			if (!youtubeAPILoaded && !isStandard) {

				// Create Script Tag
				var youtubeScript = document.createElement("script");
				// Update Script Tag Source
				youtubeScript.src = "https://www.youtube.com/iframe_api";
				// Add Script to page
				document.getElementsByTagName("head")[0].appendChild(youtubeScript);
			}

			// Listen for YouTube On Ready Event
			window.onYouTubeIframeAPIReady = initAPI;
			// build the YouTube Player
			buildYouTubePlayer();
		};

		// build the YouTube Player after APIs have been loaded
		var buildYouTubePlayer = function() {
			// Create YouTube Object to pass to youTube API
			var player = {
				// Update Element Id from Element
				elementId: config.containerId,
				// Update Asset Source from Element
				assetSrc: EB.getAssetUrl(config.containerId),
				// Update Container Id from Element
				container: config.containerId,
				// Reference to the YouTube Player Element
				player: null,
				// Interval Counter for Progress Monitoring
				monitor: null,
				// Interface & Event Dispatcher for the EBG.VideoModule
				youtubeWrapper: null,

				// Establish Object to hold new YouTube Player
				config: {
					// YouTube Video Id, found in YouTube Video URL
					videoId: youTubeVideoID,
					// YouTube Video Width
					width: config.width,
					// YouTube Video Height
					height: config.height,
					// Additional YouTube Player Vars
					playerVars: config.youtubePlayerOptions,
					// Create Event Listeners for YouTube Player
					events: {
						// Listen for Ready State
						'onReady': function() {
							onBeforeVideoStart(player);
						},
						// Listen for Errors
						'onError': function(_obj) {
							onError(_obj);
						},
						// Listen for State Change
						'onStateChange': function(_obj) {
							onStateChange(_obj, player);

						}
					}
				},
				// Create An Object to hold Player Properties
				properties: {}
			};

			if (window.youtubeAPIReady) {
				initPlayer(player);
			}
			else {
				if (!window.youtubePlayers) window.youtubePlayers = [];
				window.youtubePlayers.push(player);
			}
			youtubePlayer = player;
		};

		// youTube feature functions
		// Called once YouTube API is available
		var initAPI = function() {
			if (!window.youtubeAPIReady) { window.youtubeAPIReady = true; }

			for (var i = 0; i < window.youtubePlayers.length; i++) {
				initPlayer(window.youtubePlayers[i]);
			}
		};

		var initPlayer = function(_youtubePlayer) {
			if (!isStandard) {
				_youtubePlayer.player = new YT.Player(_youtubePlayer.container, _youtubePlayer.config);
			}
		};

		// Handle YouTube Errors
		var onError = function(_obj) {
			var error = _obj.data;

			//console.log('onError: ' + error);

			/*
			 2 – The request contains an invalid parameter value. For example, this error occurs if you specify a video ID that does not have 11 characters, or if the video ID contains invalid characters, such as exclamation points or asterisks.
			 5 – The requested content cannot be played in an HTML5 player or another error related to the HTML5 player has occurred.
			 100 – The video requested was not found. This error occurs when a video has been removed (for any reason) or has been marked as private.
			 101 – The owner of the requested video does not allow it to be played in embedded players.
			 150 – This error is the same as 101. It's just a 101 error in disguise!
			//*/
		};

		// Handle YouTube Player State Change
		var onStateChange = function(_obj, _player) {
			// Save Reference to Current State
			var state = _obj.data;
			// Handle Player State
			switch (state) {
				// Unstarted, triggered with HTML5 only
				case -1:
					break;
					// Video Ended - 0
				case YT.PlayerState.ENDED:
					// Handle onComplete Event
					onComplete(_player);
					break;
					// Video Playing - 1
				case YT.PlayerState.PLAYING:
					// Handle Playing Event
					onResume(_player);
					break;
					// Video Paused Event - 2
				case YT.PlayerState.PAUSED:
					// Handle Paused Event
					onPause(_player);
					break;
					// Video Buffering - 3
				case YT.PlayerState.BUFFERING:
					// Do Something
					break;
					// Video Cued - 5
				case YT.PlayerState.CUED:
					// Do Something
					break;
			}
		};

		// Triggered on replay (single video) and next (playlist)
		var onBeforeVideoStart = function(_youtubePlayer) {
			// Stop Monitoring the Video
			stopProgressMonitor(_youtubePlayer);
			// Start Monitor the Video
			startProgressMonitor(_youtubePlayer);
			// Save YouTube Properties
			_youtubePlayer.properties = {
				// Save Reference to Player Volume Method
				volume: _youtubePlayer.player.getVolume(),
				// Save Reference to Player Muted Method
				muted: _youtubePlayer.player.isMuted(),
				// Save Reference to Player Time Method
				currentTime: _youtubePlayer.player.getCurrentTime(),
				// Playing Timer
				triggerPause: null
			};

			// Create New YouTube Wrapper
			_youtubePlayer.youtubeWrapper = new youtubeWrapper(_youtubePlayer);

			// Check If EBG Object Exists
			if (typeof EBG != "undefined" && typeof EBG.VideoModule != "undefined") {
				// Initialize EBG Video Module
				var videoModule = new EBG.VideoModule(_youtubePlayer.youtubeWrapper);
			}
		};

		// Handle On Complete Event, Dispatch Ended Event
		var onComplete = function(_youtubePlayer) {
			_youtubePlayer.youtubeWrapper.dispatchEvent("ended");
		};

		// Handle Playing Event
		var onResume = function(_youtubePlayer) {
			// Dispath Playing Event
			_youtubePlayer.youtubeWrapper.dispatchEvent("play");
			// Stop Timer
			clearTimeout(_youtubePlayer.triggerPause);
			// Clear Timer
			_youtubePlayer.triggerPause = null;
		};

		// Handle Pause Event
		var onPause = function(_youtubePlayer) {
			// Save Reference to Current Video Time
			var vidTime = _youtubePlayer.player.getCurrentTime();
			// Save Reference to Video Duration
			var vidDuration = _youtubePlayer.player.getDuration();

			// At the end of the video, PAUSED is triggered before ENDED. Don't track this as pauses interaction.
			if (vidTime < vidDuration && !_youtubePlayer.triggerPause) {
				// Clear Timer
				_youtubePlayer.triggerPause = null;
				// Start Pause Timer
				_youtubePlayer.triggerPause = setTimeout(function() {
					_youtubePlayer.youtubeWrapper.dispatchEvent("pause");
				}, 250);
			}
		};

		// Handle Progress Monitor
		var startProgressMonitor = function(_youtubePlayer) {
			// Create Progress Timer
			_youtubePlayer.monitor = window.setInterval(function() {
				// Establish Reference to Player Volume, Check if Muted
				var vol = _youtubePlayer.player.isMuted() ? 0 : _youtubePlayer.player.getVolume();
				// Check for Volume Change
				if (_youtubePlayer.properties.volume !== vol || _youtubePlayer.properties.muted !== _youtubePlayer.player.isMuted()) {
					// Update Volume
					_youtubePlayer.properties.volume = vol;
					// Update Mute State
					_youtubePlayer.properties.muted = _youtubePlayer.player.isMuted();
					// Dispatch Volume Change Event
					_youtubePlayer.youtubeWrapper.dispatchEvent("volumechange");
				}

				// Check For Time Change
				if (_youtubePlayer.properties.currentTime !== _youtubePlayer.player.getCurrentTime()) {
					// Check to see if User is Seeking
					if (Math.abs(_youtubePlayer.player.getCurrentTime() - _youtubePlayer.properties.currentTime) > 1) {
						// Dispatch Seeking Event
						_youtubePlayer.youtubeWrapper.dispatchEvent("seeking");
						// Do Not Trigger Pause, Stop Timer
						clearTimeout(_youtubePlayer.triggerPause);
						// Clear Timer
						_youtubePlayer.triggerPause = null;
					}
					// Update Current Time
					_youtubePlayer.properties.currentTime = _youtubePlayer.player.getCurrentTime();
					// Dispatch Time Event
					_youtubePlayer.youtubeWrapper.dispatchEvent("timeupdate");
				}
			}, 200);
		};

		// Stop Progress Monitor
		var stopProgressMonitor = function(_youtubePlayer) {
			window.clearInterval(_youtubePlayer.monitor);
		};

		// Open Playback controls and player settings
		// Make Player Resize Method Public
		var setSize = function(_h, _w) {
			youtubePlayer.player.setSize(_h, _w);
		};

		// Make Player Play Method Public
		var playVideo = function() {
			youtubePlayer.player.playVideo();
		};

		// Make Player Pause Method Public
		var pauseVideo = function() {
			youtubePlayer.player.pauseVideo();
		};

		// Make Player Stop Method Public
		var stopVideo = function() {
			youtubePlayer.player.stopVideo();
		};

		// Make Player seekTo Method Public
		var seekTo = function(_seconds, _allowSeekAhead) {
			youtubePlayer.player.seekTo(_seconds, _allowSeekAhead);
		};

		// Handle the loading of new YouTube video
		var loadVideo = function(_youTubeVideoID) {
			// update asset Id
			youTubeVideoID = _youTubeVideoID;
			// retrieve video data , if videoID changes play new video and reset tracking
			var videoData = youtubePlayer.player.getVideoData();

			try {
				// verify this is a new video
				if (videoData && videoData.video_id != youTubeVideoID) {
					// rebuild youtube wrapper
					youtubePlayer.youtubeWrapper = new youtubeWrapper(youtubePlayer);
					// update EBG Video Module
					var videoModule = new EBG.VideoModule(youtubePlayer.youtubeWrapper);
					// Play new Video
					youtubePlayer.player.loadVideoById(youTubeVideoID);
				}
			}
			catch (e) {}
		};

		var cueVideo = function(_youTubeVideoID) {
			// update asset Id
			youTubeVideoID = _youTubeVideoID;
			// retrieve video data , if videoID changes cue new video and reset tracking
			var videoData = youtubePlayer.player.getVideoData();

			try {
				// verify this is a new video
				if (videoData && videoData.video_id != youTubeVideoID) {
					// rebuild youtube wrapper
					youtubePlayer.youtubeWrapper = new youtubeWrapper(youtubePlayer);
					// update EBG Video Module
					var videoModule = new EBG.VideoModule(youtubePlayer.youtubeWrapper);
					// // load new video source
					youtubePlayer.player.cueVideoById(youTubeVideoID);
				}
			}
			catch (e) {}
		};

		var unload = function() {
			youtubePlayer.player.destroy();
		};

		// DO NOT REMOVE THE FOLLOWING
		//=================================================
		// Utility Functions
		//-------------------------------------------------

		// Debugging
		var log = function() { // this is a closure-compiled version of the original code
			if (isDebug) {
				var b, a;
				b = Array.prototype.slice.call(arguments);
				a = new Date();
				a = scriptName + " (" + a.getFullYear() + "-" + a.getMonth() + "-" + a.getDate() + " " + (("0" + a.getHours()).slice(-2)) + ":" + (("0" + a.getMinutes()).slice(-2)) + ":" + (("0" + a.getSeconds()).slice(-2)) + "." + (("00" + a.getMilliseconds()).slice(-3)) + "): ";
				b.unshift(a);
				try {
					window.console && console.log && (console.log.apply ? console.log.apply(console, b) : console.log(b));
				}
				catch (d) {}
			}
		};

		// Track Ad Features - accepts interaction name and impression type
		var trackAdFeatures = function(_interaction, _noun) {
			// Establish var to track local mode
			var isServed;
			// Verify ad is not local
			try {
				isServed = EB._isServingMode();
			}
			catch (err) {}

			if (isServed && window.trackYouTubeFeature == false) {
				try {
					// Update Boolean
					window.trackYouTubeFeature = true;
					// Grab Version ID
					var adId = EB._adConfig.adId;
					// Establish reference for Version id
					var versionID;
					// Grab Version ID for mass versioning
					try {
						versionID = EB._adConfig.massVersioning.adVersions.split("_")[0];
					}
					catch (err) {
						versionID = "";
					}
					// Determine if tag is SAS
					var isSAS = (adId.toString().length >= 10);
					// Build Base Url for SAS and MDX
					var baseURL = (isSAS) ? "https://bs.serving-sys.com/Serving/adServer.bs?cn=display&c=19&pli=1073952795&adid=1073972634&ord=[timestamp]&rtu=-1&pcp=$$adID=" + adId + "|vID=" + versionID + "|interactionName=" : "https://bs.serving-sys.com/BurstingPipe/adServer.bs?cn=tf&c=19&mc=imp&pli=16478984&PluID=0&ord=%time%&rtu=-1&pcp=$$adID=" + adId + "|vId=" + versionID + "|interactionName=";
					// Build Tracking Pixel
					var trackingPixel = baseURL + _interaction + "|noun=" + _noun + "$$";
					// Fire Tracking Pixel by creating a new image.
					new Image().src = trackingPixel;

				}
				catch (err) {}
			}
		};

		var youtubeWrapper = function(_config) {
			// Establish Reference to script
			var self = this;
			// Establish Reference to YouTube ID from Config Object
			var id = _config.elementId;
			// Establish Reference to Player container from Config Object
			var player = _config.player;
			// Establish Reference to Asset Url for tracking
			var src = youTubeVideoID;

			var localPath;

			// verify working from live tag
			if (EB._adConfig !== null){
				// loop through assets
				for (var i in EB._adConfig.assets) {
					// check for match with current video id
					if (EB._adConfig.assets[i].dsPath.indexOf(src) != -1) {
						// get asset path
						localPath = EB._adConfig.assets[i].dsPath;
						// build full asset path
						src = EB._adConfig.resourcePath + localPath;
						break;
					}
				}
			}

			// Create Array to hold Event Listeners
			self.listeners = [];

			// Mimic the Video Module Id Method, return YouTube Video ID
			Object.defineProperty(self, "id", {
				get: function() {
					return id;
				}
			});
			// Mimic the Video Module Source Method, Return Dummy Asset URL used for tracking
			Object.defineProperty(self, "src", {
				get: function() {
					return src;
				}
			});
			// Mimic the Video Module Current Source Method, Return Dummy Asset URL used for tracking
			Object.defineProperty(self, "currentSrc", {
				get: function() {
					return src;
				}
			});
			// Mimic the Video Module Volume Method, return 0 - 100
			Object.defineProperty(self, "volume", {
				get: function() {
					return player.getVolume();
				}
			});
			// Mimic the Video Module Mute Method, returns true/false
			Object.defineProperty(self, "muted", {
				get: function() {
					return player.isMuted();
				}
			});
			// Mimic the Video Module Current Time Method, returns seconds
			Object.defineProperty(self, "currentTime", {
				get: function() {
					return player.getCurrentTime();
				}
			});
			// Mimic the Video Module Duration Method, returns seconds
			Object.defineProperty(self, "duration", {
				get: function() {
					return player.getDuration();
				}
			});
			// Youtube doesn't support Fullscreen, return false
			Object.defineProperty(self, "webkitSupportsFullscreen", {
				get: function() {
					return false;
				}
			});
			// Youtube doesn't support Fullscreen, return false
			Object.defineProperty(self, "webkitDisplayingFullscreen", {
				get: function() {
					return false;
				}
			});

			return self;
		};

		youtubeWrapper.prototype = {
			// Public Methods that mimic the <video> element's methods
			addEventListener: function(_event, _listener, _bubbles) {
				// Add Event Listener to Listener Array
				this.listeners.push({
					event: _event,
					listener: _listener,
					bubbles: _bubbles
				});
			},
			// Handle the Removal of Event Listeners
			removeEventListener: function(_event) {
				// Loop through Listener Array
				for (var i = 0; i < this.listeners.length; i++) {
					// Check for Event
					if (this.listeners[i].event === _event) {
						// Remove Event
						this.listeners.splice(i, 1);
					}
				}
			},
			// Handle Play Function
			play: function() {
				this.player.play();
			},

			// Non-Public Methods, used by the YouTube component
			dispatchEvent: function(_event, _info) {
				// Loop through Listeners Array
				for (var i = 0; i < this.listeners.length; i++) {
					// Establish Refence to current Listener
					var eventListener = this.listeners[i];
					// Check for Event
					if (eventListener.event === _event) {
						// Create Object to hold Params
						var params = {
							type: _event,
							info: _info
						};
						// Check for function
						if (typeof(eventListener.listener) === 'function') {
							// Add Params to Event Listener
							eventListener.listener(params);
						}
						else {
							// Fire Event
							eventListener.listener.handleEvent(params);
						}
					}
				}
			}
		};

		var prepareFeature = function() {
			// Track Ad Feature
			trackAdFeatures("impression", "AF_" + scriptName + "_" + blockId);
			// init script
			init();
		};

		prepareFeature();

		// Return functions you want publically available
		return {
			playVideo: playVideo,
			pauseVideo:	pauseVideo,
			stopVideo: stopVideo,
			seekTo: seekTo,
			loadVideo: loadVideo,
			cueVideo: cueVideo,
			unload: unload,
			setSize: setSize
		};
	};
}());
